; Assembly Source File
; Created 21/06/2003, 13:36:27
 include "include/event_id.h"
 include "include/ConfLib.h"
 include "include/utsr_events.h"
 include "include/utsr_func.h"
 include "include/tios.h"
 include "actions.h"
    xdef   _main
    xdef   _ti89
    xdef   _ti92plus
    xdef   _v200
    xdef   _ti89ti
;    xdef   _nosavescreen
	DEFINE	_version01
   	xdef	microshl@0000
   	xdef	microshl@0001
	xdef	microshl@0002
	xdef	microshl@0003
	xdef	microshl@0004

RAM_lib equ 1  	; 0 -> lib en RAM
		; 1 -> lib en archive 

debug_str macro
 ifeq 0
;DEBUGGGGGGGGGGGGGGGGG
 movem.l a0-a1/d0-d2,-(a7)
 move.w  #4,-(a7)
 pea     \debug_str(pc)
 move.w  #0,-(a7)
 move.w  #0,-(a7)
 move.l  200,a0
 move.l  1700(a0),a0
 jsr     (a0)
 move.l  200,a0
 move.l  324(a0),a0
 jsr     (a0)
 lea     10(a7),a7
 movem.l (a7)+,a0-a1/d0-d2
 bra   \skip_debug
\debug_str:
 dc.b    "hello",0
\skip_debug:
;DEBUGGGGGGGGGGGGGGGGG
 endc
 endm
_main:
 movem.l d3-d7/a2-a6,-(a7)
 move.l  200,a5
;On vrifie d'abord que la calc a une ams >= 2.06
 move.w  #ROM_VERSION,d0
 andi.w  #$0FFF,d0
 cmpi.w  #$0205,d0
 ble     tsr_ams_version_error
 
; lea     tsr_name(pc),a0
; jsr     tsrlib::is_present
; tst.w   d0
; bne     tsr_already;on regarde si MicroShl est dj install

; On va pouvoir commencer  prparer le TSR
 lea     tsr_data(pc),a6
;d'abord on cherche le handle du HOME 'pseudo-folder' contenant les rpertoires
 move.w  #tios::FolderListHandle,HOME-OO(a6)
 beq     tsr_ams_version_error;n'arrive jamais
;Maintenant on cherche le TaskID du Home
 pea     home_taskname(pc)
 move.l  4432(a5),a0;EV_getAppID 
 jsr     (a0)
 addq.l  #4,a7
 move.w  d0,HomeID-OO(a6)
;Maintenant on cherche le TaskID du desktop
 pea     desktop_taskname(pc)
 move.l  4432(a5),a0;EV_getAppID 
 jsr     (a0)
 addq.l  #4,a7
 move.w  d0,DesktopID-OO(a6)
;Maintenant on va chercher l'adresse des donnes utilises par le Desktop
 moveq   #4,d1
 bsr     OO_find_attribute
 tst.w   d0
 beq     tsr_ams_version_error;n'arrive jamais
 move.l  16(a0),a0
 move.l  a0,DataDesktop-OO(a6)
;On crit MicroShl dans le folder F3 du desktop :)
 move.l  #'Micr',88(a0)
 move.l  #'oShl',92(a0)
; maintenant le TSR est prt  tre install

 move.w  #UTSR_AUTHORIZE_DLG,-(a7)
 pea     data_tsr(pc)
 move.w  #1,-(a7); 2 fonctions 
 move.l  #_tsr_microshl_end-_tsr_microshl_beginning,d0
 move.l  d0,-(a7)
 pea     _tsr_microshl_beginning(pc)
 jsr     utsrlib@0000
 lea     16(a7),a7
;On installe le TSR 
 tst.w   d0
 beq     tsr_memory_error

 move.l  868(a5),a0;MO_currentOptions
 jsr     (a0)
 move.l  4380(a5),a0;MO_option
 move.w  #2,38(a0)
 clr.w   -(a7)
 move.l  876(a5),a0;MO_digestOptions
 jsr     (a0)
 addq.l  #2,a7
; bsr     _shl_reload_globals
 pea     tsr_success(pc)
tsr_disp_msg:
 move.l  920(a5),a0
 jsr     (a0)
 addq.l  #4,a7
 movem.l (a7)+,d3-d7/a2-a6
 rts
tsr_memory_error:
 pea     tsr_error(pc)
 bra     tsr_disp_msg
tsr_ams_version_error:
 pea     tsr_version(pc)
 bra     tsr_disp_msg
tsr_already:
 pea     tsr_already_installed(pc)
 bra     tsr_disp_msg
tsr_already_installed:
 dc.b    'MicroShl dj install',0
tsr_version:
 dc.b    'AMS 2.07+ demande',0
tsr_success:
 dc.b    'MicroShl Install',0
tsr_error:
 dc.b    'Erreur',0
 even

_tsr_microshl_beginning:
_tsr_microshl:
 dc.b    'MicroShl'
_tsr_microshl_id:
task_id:
 dc.w    0
_tsr_microshl_hook:
 movem.l d3-d7/a2-a6,-(a7)
 move.l  44(a7),a4
 move.l  200,a5
 bsr     my_tsr
 movem.l (a7)+,d3-d7/a2-a6
 rts
 include "microshl_tsr.h"
 ifeq RAM_lib
 include "ushlib\ushlib.h"
 endc
_tsr_microshl_end:



desktop_taskname:
 dc.b     'TIDSKTOP',0,0
home_taskname:
 dc.b     'TIHOME',0,0
 ifne RAM_lib
 include "ushlib\ushlib.h"
 endc

data_tsr:
 dc.w     UTSR_EV_HOOK,_tsr_microshl_hook-_tsr_microshl


 EXTRA_RAM_TABLE
 EXTRA_RAM_ADDR 0000,add_x,0,40
 EXTRA_RAM_ADDR 0001,add_y,18,18
 EXTRA_RAM_ADDR 0002,ecran_1,$0012,$2612
 EXTRA_RAM_ADDR 0003,ecran_2,$EF5C,$EF78
 EXTRA_RAM_ADDR 0004,line_width,4,5
 EXTRA_RAM_ADDR 0005,column_height,2,3
 EXTRA_RAM_ADDR 0006,rect_268_x,19,34
 EXTRA_RAM_ADDR 0007,rect_268_y,13,13
 EXTRA_RAM_ADDR 0008,affich_info_x,123,150
 EXTRA_RAM_ADDR 0009,titre_1,$1600,$2500
 EXTRA_RAM_ADDR 000A,titre_2,$7B0D,$CB0D
 EXTRA_RAM_ADDR 000B,batt_stat_x,13,23
 EXTRA_RAM_ADDR 000C,displayed_var,8,15
