; Header File
; Created 22/06/2004; 15:08:26


file equ 0
ViewerHandle equ 2
exec_flags equ 4
Signature equ 6
TempHandle0 equ 10
TempHandle1 equ 12
exec_handle equ 14
exec_address equ 16
EXEC_size equ 20

exec_archived equ 0
exec_zip equ 1
exec_xpak equ 2
handle_locked equ 3
handle_text equ 5
handle_basic equ 6
handle_asm equ 7
; Flags
; original archiv  -> remettre le handle et le flag  leur place         0
;          ram & ZIP -> recompresser                                      1
;          ram & XPAK -> recompresser                                     2
;	   ram & locked -> ne pas dverrouiller				  3
;          ram & ppg -> rcuprer l'original				  4
;          basic                                                          5
;          text                                                           6
;          ASM                                                            7

; Flags+1
; viewer   archiv   -> remettre le handle et le flag  leur place        0
;          ram & ZIP -> recompresser                                      1
;          ram & XPAK -> recompresser                                     2
;	   ram & locked -> ne pas dverrouiller				  3
;          ram & ppg -> rcuprer l'original				  4


;get_type
;       <- a1.l pointe vers TAG
;	<- a0.l pointe vers dbut du fichier
;	-> a1.l pointe vers TYPE
; 	met  jour Flags+1-OO(a6)
microshl@0001:
 movem.l a1-a6/d0-d7,-(a7)
 lea     data(pc),a6
 move.l  200,a5
 move.l  (6+8)*4+4(a7),a4; a4 == EXEC* file
;d'abord vrifier que la structure est valide
 move.l  a4,d0
 beq     \exit
 btst.b  #0,d0
 bne     \exit
;effacer la structure
 moveq   #8,d0
 lea     2(a4),a0
\clear:
 clr.w   (a0)+
 dbra    d0,\clear
 moveq   #0,d4
 move.w  file(a4),d0
 bsr     prepare_file
 tst.w   d0
 beq     \error
;on va voir si le type est associ  qqc
 lea     Signature(a4),a0
 lea     key_str(pc),a1
 move.l  (a0)+,(a1)+

 lea     viewer_name(pc),a0
 moveq   #17,d0
\clr_viewer:
 clr.b   (a0)+
 dbra    d0,\clr_viewer
 pea     default(pc)
 moveq   #17,d0
 move.l  d0,-(a7)
 pea     complete_viewer_name(pc)
 pea     key_str(pc)
 pea     main_app_section_str(pc)
 pea     file_str(pc)
 ifne RAM_lib
 jsr     conflib@0003
 endc
 ifeq RAM_lib
 clr.b   -(a7)
 move.w  #3,-(a7)
 pea     conflib_str(pc)
 jsr     kernel::LibsExec
 addq.l  #8,a7
 endc
 lea     24(a7),a7
;normalement on a le nom de l'association
 lea     complete_viewer_name(pc),a0
 tst.b   (a0)
 beq     \relocate
;il est associ  qqc
; -> on va chercher le viewer associ
 moveq   #0,d1
 moveq   #17,d0
 lea     viewer_name(pc),a1
 clr.b   (a1)+
\search_slash:
 move.b  (a0),(a1)
 tst.b   (a0)
 beq     \exit_search
 addq.l  #1,a1
 cmp.b   #'\',(a0)+
 bne     \skip_search
 moveq   #1,d1
\skip_search:
 dbra    d0,\search_slash
\exit_search:
;<- a0.l SYM_STR du viewer
 tst.b   d1
 bne     \search_viewer_in_folder
 lea     viewer_name+1(pc),a1
 move.l  #kernel::SystemDir,a0
\copy_system_folder:
 tst.b   (a0)
 beq     \exit_copy_system_folder
 move.b  (a0)+,(a1)+
 bra     \copy_system_folder
\exit_copy_system_folder:
 move.b  #'\',(a1)+
 lea     complete_viewer_name(pc),a0
\copy_complete_name:
 tst.b   (a0)
 beq     \exit_copy_complete_name
 move.b  (a0)+,(a1)+
 bra     \copy_complete_name
\exit_copy_complete_name:
 clr.b   (a1) 
\search_viewer_in_folder
 clr.w   -(a7)
 move.l  a1,-(a7)
 move.l  $283*4(a5),a0;SymFindPtr
 jsr     (a0)
 addq.l  #6,a7
\found:
 move.l  a0,d0; on trouve pas l'association
 beq     \try_app_flash
 move.w  12(a0),d0
 beq     \error
 move.w  d0,ViewerHandle(a4)
 moveq   #1,d4
 bsr     prepare_file
 tst.w   d0 
 beq     \relocate;erreur : on essaie de le lancer sans rien :)
;on va pusher le nom du fichier appell sur la pile, histoire que le viewer puisse le retrouver
 pea     symname1-data+1(a6)
 bsr     push_zstr
 addq.l  #4,a7
; bra     \relocate
\relocate:
;on regarde si le prog  lancer est un asm, on le reloge, toussa
;si a merde, on va  \error
 btst.b  #handle_asm,exec_flags(a4)
 bne     \exit
\error:
 clr.w   exec_handle(a4)
\exit:
 movem.l (a7)+,a1-a6/d0-d7
 rts
\try_app_flash:
 bsr     exec_extension_app_flash
 bra     \exit
;\relocate
; btst.b  #handle_asm,exec_flags(a4)
; bne     \execute_asm
; clr.w   exec_handle(a4)
;\execute_asm:
; move.w  exec_handle(a4),d0
; beq     \error
; bra     \exit

 even
key_str:
 dc.b    'TYPE',0
main_app_section_str:
 dc.b    'microshl'
;second_app_section_str:
; dc.b    'ushlib_second'
default:
 dc.b    0
conflib_str:
 dc.b    'conflib',0
file_str:
 dc.b    'tsr_conf'
 dc.b    0,0
 even
 
prepare_file:
;<- d0.w handle
;<- d4.w 0 si file, 1 si viewer
;-> d0.w = 1 OK
;dtruit d5,a0-a1
;remplit le sn #1 si programme
;remplit le sn #2 si viewer
 move.w  d0,exec_handle(a4)
 move.w  d0,d5

;on regarde si le handle est verrouill
 move.w  d0,d3
 move.w  d3,-(a7)
 move.w  d3,-(a7)
 move.l  620(a5),a0;HeapGetLock
 jsr     (a0)
 addq.l  #2,a7
 tst.w   d0
 beq     \skip_lock
 bset.b  #handle_locked,exec_flags(a4,d4.w)
\skip_lock:
 addq.l  #2,a7

;on cherche un SymPtr vers le fichier
 move.w  d5,d0
 jsr     kernel::Hd2Sym
 move.l  a0,d0
 beq     \error
 move.w  12(a0),d0;pas de handle
 beq     \error
 bsr     deref
 move.l  a4,d0;on vrifie que le handle est valide
 beq     \error
 btst.b  #0,d0
 bne     \error
;tout va bien dans la VAT :)
;on va rcuprer le type / signature du fichier
 moveq   #0,d1
 move.w  (a0),d1
 lea     1(a0,d1.l),a1
 bsr     get_type

;on regarde si le fichier analys est bien un excutable asm
 bclr.b  #handle_asm,exec_flags(a4)
 cmp.b   #243,(a1)
 bne     \skip_asm_type
 bset.b  #handle_asm,exec_flags(a4)
\skip_asm_type:
 cmp.b   #220,(a1)
 bne     \skip_basic_type
 bset.b  #handle_basic,exec_flags(a4)
\skip_basic_type:
 cmp.b   #$E0,(a1)
 bne     \skip_text_type
 bset.b  #handle_text,exec_flags(a4)
\skip_text_type:
 tst.b   d4
 bne     \skip_type

;c'est bon, c'est dans la structure
\skip_type:
 btst.b  #Flags_ZIP,Flags+1-OO(a6)
 beq     \skip_ZIP
 bset.b  #exec_zip,exec_flags(a4,d4.w)
\skip_ZIP:
 btst.b  #Flags_XPAK,Flags+1-OO(a6)
 beq     \skip_XPAK
 bset.b  #exec_xpak,exec_flags(a4,d4.w)
\skip_XPAK:
 cmp.l   #tios::ROM_base,a0
 ble     \skip_archive
 bset.b  #exec_archived,exec_flags(a4,d4.w)
\skip_archive:
;c'est fait :)
;maintenant, il faut enregistrer la structure de get_type dans la structure EXEC
 lea     Signature(a4),a0
 addq.l  #type_signature,a1
 move.b  (a1)+,(a0)+
 move.b  (a1)+,(a0)+
 move.b  (a1)+,(a0)+
 move.b  (a1)+,(a0)+


;on rcupre un pointeur vers le SymEntry du rpertoire du programme
;pour construire des SymStr
 bsr     hdle2symentry_var_folder
 move.l  a2,d0
 beq     \error
 moveq   #1,d0
 add.b   d4,d0
 bsr     mk_sn_var
;c'est bon, on a notre SymStr

 btst.b  #exec_zip,exec_flags(a4,d4.w)
 bne     \ram_copy
 btst.b  #exec_archived,exec_flags(a4,d4.w)
 beq     \skip_temp_copy
;le programme est archiv||compress, on va le recopier en RAM
\ram_copy:
 move.w  d5,-(a7)
 move.l  632(a5),a0;HeapSize
 jsr     (a0)
 addq.l  #2,a7
 move.l  d0,d3
 move.l  d0,-(a7)
 move.l  576(a5),a0;HeapAlloc
 jsr     (a0)
 addq.l  #4,a7
 move.w  d0,d1
 beq     \error
 subq.w  #1,d3
 bsr     deref
 move.l  a0,a1
 move.w  d5,d0
 bsr     deref
\loop0:
 move.b  (a0)+,(a1)+
 dbra    d3,\loop0 
 add.w   d4,d4
 move.w  d1,TempHandle0(a4,d4.w)
 move.w  d1,exec_handle(a4)
 lsr.w   #1,d4
; move.w  d0,d1
 move.w  d5,d0
 jsr     kernel::Hd2Sym
 move.w  d1,12(a0)
 bclr.b  #1,10(a0);flag archive
 bclr.b  #3,11(a0);flag lock
\skip_temp_copy:
;l faudra le dcompresser, toussa
 btst.b  #exec_zip,exec_flags(a4,d4.w)
 beq     \skip_decompress_zip
 moveq   #1,d0
 add.b   d4,d0
 bsr     use_ziplib
 bsr     use_compress
 tst.w   d0
 beq     \error
;il faudra grer les erreurs de lib ici :/
\skip_decompress_zip:
 btst.b  #exec_xpak,exec_flags(a4,d4.w)
 bne     \error
 moveq   #1,d0
 rts
\error:
 moveq   #0,d0
 rts
;structure type : TAG, type userlib, XR_string-1100, icne, Signature
use_compress:
;utlise le handle dcompress
 move.w  d0,-(a7)
 moveq   #1,d0
 add.b   d4,d0
 bsr     find_var_0001
 move.w  12(a0),d0
 move.w  d4,d1
 add.w   d1,d1
 move.w  d0,exec_handle(a4)
 move.w  d0,TempHandle0(a4,d1.w)
 move.w  (a7)+,d0
 rts