; Header File
; Created 05/06/2004; 02:52:00
draw_selection:
 bsr     pos_to_coord
 add.w   #7,d0
 addq.w  #2,d1
 moveq   #25,d2
 add.w   d0,d2
 moveq   #20,d3
 add.w   d1,d3
 moveq   #2,d4
 bra     graphlib0000
pos_to_coord:
 move.w  d4,d0
 mulu.w  #40,d0
 add.w   #add_x,d0
 move.w  d5,d1
 mulu.w  #35,d1
 add.w   #add_y,d1
 rts 
graphlib0000:
 lea     rect(pc),a0
 move.b  d0,(a0)
 move.b  d1,1(a0)
 move.b  d2,2(a0)
 move.b  d3,3(a0)
 move.w  d4,d0
rectangle:
 move.w  d0,-(a7)
 pea     grand_ecran(pc)
 move.l  a0,-(a7)
 move.l  1572(a5),a0;ScrRectFill
 jsr     (a0)
 lea     10(a7),a7
 rts
draw_rect: 
 movem.l d0-d5,-(a7)
 tst.w   NumVar-OO(a6)
 beq     \exit
 move.w  Col-OO(a6),d4
 move.w  Line-OO(a6),d5
 bsr     pos_to_coord 
 move.w  d0,d2
 move.w  d1,d3
 add.w   #38,d2
 add.w   #29,d3
 moveq   #2,d4
 bsr     graphlib0000
\exit:
 movem.l (a7)+,d0-d5
 rts 


affiche_variable:
;<- d3.w n de la variable
;<- d1.w n de la ligne
;<- d0.w n de la colonne
 movem.l a0-a3/d0-d7,-(a7)
 move.w  d0,d4
 move.w  d1,d5
 move.w  cur_folder-OO(a6),d0
 bsr     deref
 mulu.w  #14,d3
 lea     4(a0,d3.l),a0
 bsr     pos_to_coord
 add.w   #24,d1
 movem.l d0-d1/a0,-(a7)
 clr.w   -(a7)
 move.l  a0,-(a7)
 move.l  1628(a5),a0;DrawStrWidth
 jsr     (a0)
 addq.l  #6,a7
 move.w  d0,d2
 lsr.w   #1,d2
 movem.l (a7)+,d0-d1/a0
 movem.l d0-d1,-(a7)

 add.w   #19,d0
 sub.w   d2,d0
 bsr     affich_string
 lea     icone_folder(pc),a1
 move.l  a0,a3
 
 
 btst.b  #7,11(a0)
 bne     \affiche_icone_found;on regarde d'abord si c'est un rpertoire
 bsr     get_id_icon
 move.l  a1,d0
 bne     \affiche_icone_found
 
 lea     icone_variables(pc),a1
 move.w  12(a0),d0
 beq     \affiche_icone_found;pb : la variable n'a pas de handle
 bsr     deref
 move.l  a0,d0
 btst.b  #0,d0
 bne     \affiche_icone_found;handle avec une adresse incorrecte ! c'est maaal
 moveq   #0,d0
 move.w  (a0),d0;taille de la variable
 lea     1(a0,d0.l),a1
;l on va chercher une icne pour les progarmmes nostub
 movem.l a0/a2/d0-d1,-(a7)
 cmp.b   #$F3,(a1)
 bne     \skip_nostub
 addq.l  #2,a0
 move.l  a0,a2
 cmp.w   #$2E97,(a2)
 bne     \skip_nostub
 addq.l  #6,a2
 lea     _data_nostub_attr(pc),a1
 moveq   #3,d0
\loop_nostub_att:
 cmpm.l  (a1)+,(a2)+
 bne     \skip_nostub
 dbra    d0,\loop_nostub_att
 move.w  (a2)+,d0
 beq     \skip_nostub
 subq.w  #1,d0
 moveq   #4,d1
\loop_get_nostub_att:
 cmp.w   (a2)+,d1
 beq     \nostub_icone_found
 addq.l  #2,a2
 dbra    d0,\loop_get_nostub_att
\skip_nostub:
 movem.l (a7)+,a0/a2/d0-d1
 lea     1(a0,d0.l),a1
 bsr     get_type
 moveq   #0,d0
 move.b  3(a1),d0

 mulu    #70,d0
 lea     icone_variables(pc),a1
 lea     0(a1,d0.l),a1
\affiche_icone_found:
 movem.l (a7)+,d0-d1
 movem.l d0-d1,-(a7)
 sub.w   #23,d1
 add.w   #9,d0
 move.w  #4,-(a7)
 pea     ecran(pc)
 move.l  a1,-(a7)
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.l  1564(a5),a0;BitmapPut
 jsr     (a0)
 lea     14(a7),a7
\affich_no_icone:
 movem.l (a7)+,d0-d1
 subq.w  #7,d1
 btst.b  #1,10(a3)
 beq     \skip_archived
 lea     _archived_str(pc),a0
 bsr     affich_string
 subq.w  #6,d1
\skip_archived
 btst.b  #3,11(a3)
 beq     \skip_locked
 lea     _locked_str(pc),a0
 bsr     affich_string
 subq.w  #6,d1
\skip_locked:
 btst.b  #2,10(a3)
 beq     \skip_temp
 lea     _temp_str(pc),a0
 bsr     affich_string
; subq.w  #6,d1
\skip_temp:
 btst.b  #5,11(a3)
 beq     \skip_select
 bsr     draw_selection
\skip_select:
 movem.l (a7)+,a0-a3/d0-d7
 rts
\nostub_icone_found:
 moveq   #0,d0
 move.w  (a2)+,d0
 lea     0(a0,d0.l),a1
 movem.l (a7)+,a0/a2/d0-d1
 movem.l (a7)+,d0-d1
 movem.l d0-d1,-(a7)
 sub.w   #20,d1
 add.w   #12,d0
 move.w  #4,-(a7)
 move.l  a1,-(a7)
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.l  1688(a5),a0;DrawIcon
 jsr     (a0)
 lea     10(a7),a7
 bra     \affich_no_icone

shl_redraw:
 bsr     get_id
 clr.w   -(a7)
 move.l  1596(a5),a0;FontSetSys
 jsr     (a0)
 addq.l  #2,a7
 moveq   #0,d0
 lea     ecran(pc),a0
 bsr     rectangle
 moveq   #0,d0
 lea     titre(pc),a0
 bsr     rectangle
;tout a, c'est pour dessiner la RAM libre
 move.l  572(a5),a0;HeapAvail
 jsr     (a0)
 move.l  d0,-(a7)
 moveq   #0,d0
 move.w  #748,d0
 bsr     xr_string
 move.l  a0,-(a7)
 pea     heap_avail_str(pc)
 pea     buffer(pc)
 move.l  332(a5),a0;sprintf
 jsr     (a0)
 lea     16(a7),a7
 lea     buffer(pc),a0
 move.w  #rect_268_x+3,d0
 moveq   #1,d1
 bsr     affich_string
;fin de la RAM libre
;tout a, c'est pour dessiner le rectangle de RAM libre
; move.l  572(a5),a0;HeapAvail
; jsr     (a0)
; lsr.l   #8,d0
; lsr.l   #3,d0
; moveq   #72,d2
; add.w   d0,d2
; moveq   #72,d0
; moveq   #2,d1
; moveq   #6,d3
; moveq   #1,d4
; bsr     graphlib0000

; move.w  #1,-(a7)
; pea     grand_ecran(pc)
; pea     heapavail_rect(pc)
; move.l  1620(a5),a0;DrawClipRect
; jsr     (a0)
; lea     10(a7),a7
; moveq   #0,d0
; move.w  #748,d0
; bsr     xr_string
; move.w  #rect_268_x+3,d0
; moveq   #1,d1
; bsr     affich_string
;fin du rect

;et maintenant, l'tat des piles (n'est-ce pas, MacIntoc ?)
 bsr     batt_stat_2
 mulu.w  #10,d0
 move.l  #LCD_MEM+30*1,a0
 add.w   #batt_stat_x,a0
; move.l  #LCD_MEM+30*8+23,a0
 lea     pilesData(pc,d0.w),a1
 moveq   #4,d0
\loop_piles:
 move.b  (a1)+,(a0)+
 move.b  (a1)+,(a0)+
 lea     28(a0),a0
 dbra    d0,\loop_piles
;fin de l'tat des piles
 tst.w   NumVar-OO(a6)
 beq     shl_redraw_end
 bsr     get_first_displayed_var
 move.w  #column_height-1,d4
 moveq   #0,d1
shl_redraw_loop_1:
 move.w  #line_width-1,d5
 moveq   #0,d0
shl_redraw_loop_2:
 cmp.w   NumVar-OO(a6),d3
 beq     shl_redraw_end
 bsr     affiche_variable
 addq.w  #1,d3
 addq.w  #1,d0;colonne
 dbra    d5,shl_redraw_loop_2
 addq.w  #1,d1;ligne
 dbra    d4,shl_redraw_loop_1
shl_redraw_end:
 bsr     affich_fleches
 rts
get_first_displayed_var:
;-> d3 indice de la variable en haut  gauche
;dtruit d0
 moveq   #0,d3
 move.w  Abs-OO(a6),d3
 sub.w   Col-OO(a6),d3
 move.w  Line-OO(a6),d0
 mulu.w  #line_width,d0
 sub.w   d0,d3
 rts

pilesData: ;Tile 0
 dc.b $3F,$F8,$60,$08,$40,$08,$60,$08,$3F,$F8
 ;Tile 1
 dc.b $3F,$F8,$60,$18,$40,$38,$60,$78,$3F,$F8
 ;Tile 2
 dc.b $3F,$F8,$60,$38,$40,$78,$60,$F8,$3F,$F8
 ;Tile 3
 dc.b $3F,$F8,$60,$78,$40,$F8,$61,$F8,$3F,$F8
 ;Tile 4
 dc.b $3F,$F8,$60,$F8,$41,$F8,$63,$F8,$3F,$F8
 ;Tile 5
 dc.b $3F,$F8,$61,$F8,$43,$F8,$67,$F8,$3F,$F8
 ;Tile 6
 dc.b $3F,$F8,$63,$F8,$47,$F8,$6F,$F8,$3F,$F8
 ;Tile 7
 dc.b $3F,$F8,$7F,$F8,$7F,$F8,$7F,$F8,$3F,$F8

affich_info:
;d'abord effacer la zone de l'cran
 move.w  #rect_268_x+3,d0
 moveq   #7,d1
 move.w  #affich_info_x,d2
 moveq   #13,d3
 moveq   #0,d4
 bsr     graphlib0000
 tst.w   NumVar-OO(a6)
 beq     \exit
 bsr     deref_variable
 moveq   #8,d1
 move.w  #rect_268_x+3,d0
 bsr     affich_string
 move.w  12(a0),d0
 beq     \exit
 btst.b  #7,11(a0)
 bne     affich_info_folder
 bsr     deref
 move.l  a0,d0
 beq     \exit
 moveq   #0,d1
 move.w  (a0),d1
 lea     1(a0,d1.l),a1
 lea     _format_str_file(pc),a2
 bsr     affich_info_dec
 bsr     get_type
 lea     buffer(pc),a0
 move.l  4(a1),(a0)
 clr.b   4(a0)
 moveq   #8,d1
 moveq   #rect_268_x+73,d0
 bsr     affich_string
\exit:
 rts
affich_info_folder:
 bsr     deref
 move.l  a0,d0
 beq     \exit
 moveq   #0,d1
 move.w  2(a0),d1
 lea     _format_str_folder(pc),a2
 bsr     affich_info_dec
 
\exit
 rts

get_type:
;<- a1.l pointe vers TAG
;<- a0.l pointe vers dbut du fichier
;-> a1.l pointe vers TYPE
; met  jour Flags+1-OO(a6)
 movem.l a0/a2/d0-d2,-(a7)
 clr.b   Flags+1-OO(a6)
 move.b  (a1),d1
 lea     data_type(pc),a2
 moveq   #15,d0
\loop:
 cmp.b   (a2),d1
 beq     \exit_loop
 add.l   #8,a2
 dbra    d0,\loop
\exit_loop:
 cmp.b   #243,(a2)
 bne     \skip_asm
 cmp.l   #"68kP",6(a0)
 bne     \skip_exe
 lea     data_type_exe(pc),a2
\skip_exe:
 cmp.l   #"68kL",6(a0)
 bne     \skip_lib
 lea     data_type_lib(pc),a2
\skip_lib:
\skip_asm:

 cmp.b   #248,d1
 bne     \skip_oth
 tst.b   -2(a1)
 beq     \skip_oth
 lea     data_type_buffer(pc),a2
 move.l  #$F80E0000,(a2)
 clr.l   type_signature(a2)
 moveq   #3,d2
\sign_loop:
 tst.b   -6(a1,d2.l)
 bne     \sign_loop_0
 movem.l d1/a1,-(a7)
 moveq   #3,d1
 sub.w   d2,d1
 sub.l   #5,a1
 add.l   d2,a1
\sign_loop_1:
 move.b  0(a1,d1.l),type_signature(a2,d1.l)
 dbra    d1,\sign_loop_1
 movem.l (a7)+,a1/d1
 bra     \skip_sign
\sign_loop_0:
 dbra    d2,\sign_loop
 bra     \skip_oth
\skip_sign:
 cmp.l   #'ppg'*$100,type_signature(a2)
 bne     \skip_ppg
 move.b  #$08,3(a2)
\skip_ppg:
 cmp.l   #'ZIP'*$100,type_signature(a2)
 bne     \skip_zip
 bset.b  #Flags_ZIP,Flags+1-OO(a6)
 move.b  2(a0),d1;octet de type userlib
 lea     data_type(pc),a2
 moveq   #(type_total-1),d0
\zip_loop:
 cmp.b   type_userlib(a2),d1
 beq     \exit_zip_loop
 addq.l  #8,a2
 dbra    d0,\zip_loop
\exit_zip_loop:

;structure type : 0 TAG, 1 type userlib, 2 XR_string-1100, 3 icne, 4 Signature
\skip_zip:
\skip_oth:
 cmp.b   #220,d1
 bne     \skip_basic
 lea     data_type_func(pc),a2
 move.l  #50,d0
 move.l  a1,a0
\i_r_prgm_loop:
 cmp.b   #$19,(a0)
 beq     \i_r_prgm_l
 sub.l   #1,a0
 dbra    d0,\i_r_prgm_loop
\i_r_prgm_l:
 cmp.b   #$19,(a0)
 bne     \skip_func
 cmp.b   #$E4,1(a0)
 bne     \skip_func
 cmp.b   #$E5,2(a0)
 bne     \skip_func
 lea     data_type_prgm(pc),a2
\skip_func:
\skip_basic:
\skip_all:
 moveq   #0,d0
 move.b  2(a2),d0
 beq     \exit
 add.w   #1100,d0
 bsr     xr_string
 move.l  a0,d0
 beq     \exit
 addq.l  #type_signature,a2
 move.b  (a0)+,(a2)+
 move.b  (a0)+,(a2)+
 move.b  (a0)+,(a2)+
 move.b  (a0)+,(a2)+
 subq.l  #8,a2
\exit:
 move.l  a2,a1
 movem.l (a7)+,a0/a2/d0-d2
 rts 



affich_info_dec:
 movem.l d0-d2/a0-a1,-(a7)
 move.l  d1,-(a7)
 move.l  a2,-(a7)
 pea     buffer(pc)
 move.l  332(a5),a0
 jsr     (a0)
 lea     12(a7),a7
 moveq   #8,d1
 move.w  #rect_268_x+81,d0
 lea     buffer(pc),a0
 bsr     affich_string
 movem.l (a7)+,d0-d2/a0-a1
 rts 

affich_fleches:
;c'est l qu'il faut dessiner les jolies flches pour dire s'il y a des trop de fichiers pour tout afficher 
 movem.l d0-d3,-(a7)
 bsr     get_first_displayed_var
 cmp.w   #line_width,d3
 blt     \skip_fleche_haut
 move.w  #add_x,d0
 moveq   #4,d1
 move.w  #add_y,d1
 moveq   #19,d2
 bsr     affich_char
\skip_fleche_haut:
 add.w   #displayed_var,d3
 cmp.w   NumVar-OO(a6),d3
 bge     \skip_fleche_bas
 move.w  #add_x,d0
 move.w  #ecran_2,d2
 moveq   #0,d1
 move.b  d2,d1
 moveq   #20,d2
 sub.w   #8,d1
 bsr     affich_char
\skip_fleche_bas:
 movem.l (a7)+,d0-d3
 rts




batt_stat_2:
 movem.l a0-a1/d1-d3,-(a7)
 move.w  #$700,-(a7)
 move.l  2672(a5),a0;OSSetSR
 jsr     (a0)
 clr.w   d0
 move.b  237(a6),d0
 subq.w  #1,d0
 move.w  d0,-(a7)
 bsr     BatteryState
 move.w  d0,d3
 clr.w   -(a7)
 move.l  2672(a5),a0;OSSetSR
 jsr     (a0)
 addq.l  #6,a7
 move.w  d3,d0
 movem.l (a7)+,a0-a1/d1-d3
 rts
;unsigned short BatteryState(unsigned short is_hw_2);

; ExtendeD's routine
BatteryState:
 cmp.b   #1,HW_VERSION
 beq     \skip_hw1
 lea     $70001D,a0
 move.b  (a0),d0
 ori.b   #9,d0
 move.b  d0,(a0)
\skip_hw1:
 moveq   #6,d1
 lea     $600018,a1
\loop:
 bsr     _bat_ini;         | this initialization lacked in previous versions
 move.w  d1,d0
 lsl.w   #7,d0
 move.w  d0,(a1)
 moveq   #$6e,d0
\test:
 btst.b  #2,-$18(a1)
 dbeq    d0,\test
 beq     \quit
 dbra    d1,\loop
\quit:
 neg.w   d1
 addq.w  #6,d1
 cmp.b   #1,HW_VERSION
 beq     \skip_hw1_2;        | jump for HW1\n"
 and.b   #$F7,(a0)
 bsr     _bat_ini
 andi.b  #$F6,(a0)
\skip_hw1_2:
 move.w  d1,d0
 rts
_bat_ini:
 move.w  #$380,(a1)
 moveq   #52,d0
\wait:
 btst.b  #2,-$18(a1)
 dbeq    d0,\wait
 rts
